FLTK 1.4.4

Loading...
Searching...
No Matches
Fl_Bitmap Class Reference

The Fl_Bitmap class supports caching and drawing of mono-color (bitmap) images. More...

`#include <Fl_Bitmap.H>`

Inheritance diagram for Fl_Bitmap:

## Public Member Functions
int | cache_h ()
int | cache_w ()
Fl_Image * | copy () const
Fl_Image * | copy (int W, int H) const FL_OVERRIDE
| Creates a resized copy of the image.
void | draw (int X, int Y)
void | draw (int X, int Y, int W, int H, int cx=0, int cy=0) FL_OVERRIDE
| Draws the image to the current drawing surface with a bounding box.
| Fl_Bitmap (const char *bits, int bits_length, int W, int H)
| The constructors create a new bitmap from the specified bitmap data.
| Fl_Bitmap (const char *bits, int W, int H)
| The constructors create a new bitmap from the specified bitmap data.
| Fl_Bitmap (const uchar *bits, int bits_length, int W, int H)
| The constructors create a new bitmap from the specified bitmap data.
| Fl_Bitmap (const uchar *bits, int W, int H)
| The constructors create a new bitmap from the specified bitmap data.
void | label (Fl_Menu_Item *m) FL_OVERRIDE
| This method is an obsolete way to set the image attribute of a menu item.
void | label (Fl_Widget *w) FL_OVERRIDE
| This method is an obsolete way to set the image attribute of a widget or menu item.
void | uncache () FL_OVERRIDE
| If the image has been cached for display, delete the cache data.
virtual | ~Fl_Bitmap ()
| The destructor frees all memory and server resources that are used by the bitmap.
Public Member Functions inherited from Fl_Image
virtual class Fl_Shared_Image * | as_shared_image ()
| Returns whether an image is an Fl_Shared_Image or not.
virtual void | color_average (Fl_Color c, float i)
| The color_average() method averages the colors in the image with the provided FLTK color value.
Fl_Image * | copy () const
| Creates a copy of the image in the same size.
int | count () const
| Returns the number of data values associated with the image.
int | d () const
| Returns the image depth.
const char *const * | data () const
| Returns a pointer to the current image data array.
int | data_h () const
| Returns the height of the image data.
int | data_w () const
| Returns the width of the image data.
virtual void | desaturate ()
| The desaturate() method converts an image to grayscale.
void | draw (int X, int Y)
| Draws the image to the current drawing surface.
int | fail () const
| Returns a value that is not 0 if there is currently no image available.
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth.
int | h () const
| Returns the current image drawing height in FLTK units.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out.
int | ld () const
| Returns the current line data size in bytes.
virtual void | release ()
| Releases an Fl_Image - the same as '`delete` `this'`.
virtual void | scale (int width, int height, int proportional=1, int can_expand=0)
| Sets the drawing size of the image.
int | w () const
| Returns the current image drawing width in FLTK units.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.

## Public Attributes
int | alloc_array
| Non-zero if array points to bitmap data allocated internally.
const uchar * | array
| pointer to raw bitmap data

## Friends
class | Fl_Graphics_Driver

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Image
static Fl_Labeltype | define_FL_IMAGE_LABEL ()
static Fl_RGB_Scaling | RGB_scaling ()
| Returns the currently used RGB image scaling method.
static void | RGB_scaling (Fl_RGB_Scaling)
| Sets the RGB image scaling method used for copy(int, int).
static Fl_RGB_Scaling | scaling_algorithm ()
| Gets what algorithm is used when resizing a source image to draw it.
static void | scaling_algorithm (Fl_RGB_Scaling algorithm)
| Sets what algorithm is used when resizing a source image to draw it.
Static Public Attributes inherited from Fl_Image
static const int | ERR_FILE_ACCESS = -2
static const int | ERR_FORMAT = -3
static const int | ERR_MEMORY_ACCESS = -4
static const int | ERR_NO_IMAGE = -1
static bool | register_images_done = false
| True after fl_register_images() was called, false before.
Protected Member Functions inherited from Fl_Image
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current data pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it.
int | draw_scaled (int X, int Y, int W, int H)
| Draw the image to the current drawing surface rescaled to a given width and height.
void | h (int H)
| Sets the height of the image data.
void | ld (int LD)
| Sets the current line data size in bytes.
void | w (int W)
| Sets the width of the image data.
Static Protected Member Functions inherited from Fl_Image
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Detailed Description

The Fl_Bitmap class supports caching and drawing of mono-color (bitmap) images.

Images are drawn using the current color.

## Constructor & Destructor Documentation

## ◆ Fl_Bitmap() [1/4]

Fl_Bitmap::Fl_Bitmap | ( | const uchar * | bits,
|  | int | W,
|  | int | H )
| inline

The constructors create a new bitmap from the specified bitmap data.

See also
  Fl_Bitmap(const uchar *bits, int bits_length, int W, int H)

## ◆ Fl_Bitmap() [2/4]

Fl_Bitmap::Fl_Bitmap | ( | const char * | bits,
|  | int | W,
|  | int | H )
| inline

The constructors create a new bitmap from the specified bitmap data.

See also
  Fl_Bitmap(const char *bits, int bits_length, int W, int H)

## ◆ Fl_Bitmap() [3/4]

Fl_Bitmap::Fl_Bitmap | ( | const uchar * | bits,
|  | int | bits_length,
|  | int | W,
|  | int | H )

The constructors create a new bitmap from the specified bitmap data.

If the provided array is too small to contain all the image data, the constructor will not generate the bitmap to avoid illegal memory read access and instead set `data` to NULL and `ld` to `ERR_MEMORY_ACCESS`.

Parameters

  bits | bitmap data, one pixel per bit, rows are rounded to the next byte
  bits_length | length of the `bits` array in bytes
  W | image width in pixels
  H | image height in pixels

See also
  Fl_Bitmap(const char *bits, int bits_length, int W, int H), Fl_Bitmap(const uchar *bits, int W, int H)

## ◆ Fl_Bitmap() [4/4]

Fl_Bitmap::Fl_Bitmap | ( | const char * | bits,
|  | int | bits_length,
|  | int | W,
|  | int | H )

The constructors create a new bitmap from the specified bitmap data.

If the provided array is too small to contain all the image data, the constructor will not generate the bitmap to avoid illegal memory read access and instead set `data` to NULL and `ld` to `ERR_MEMORY_ACCESS`.

Parameters

  bits | bitmap data, one pixel per bit, rows are rounded to the next byte
  bits_length | length of the `bits` array in bytes
  W | image width in pixels
  H | image height in pixels

See also
  Fl_Bitmap(const uchar *bits, int bits_length, int W, int H), Fl_Bitmap(const char *bits, int W, int H)

## Member Function Documentation

## ◆ copy()

Fl_Image * Fl_Bitmap::copy | ( | int | W,
|  | int | H ) const
| virtual

Creates a resized copy of the image.

It is recommended not to call this member function to reduce the size of an image to the size of the area where this image will be drawn, and to use Fl_Image::scale() instead.

The new image should be released when you are done with it.

Note: since FLTK 1.4.0 you can use Fl_Image::release() for all types of images (i.e. all subclasses of Fl_Image) instead of operator delete for Fl_Image's and Fl_Image::release() for Fl_Shared_Image's.

The new image data will be converted to the requested size. RGB images are resized using the algorithm set by Fl_Image::RGB_scaling().

For the new image the following equations are true:

- w() == data_w() == `W`
- h() == data_h() == `H`

Parameters

  [in] | W,H | Requested width and height of the new image

Note
  The returned image can be safely cast to the same image type as that of the source image provided this type is one of Fl_RGB_Image, Fl_SVG_Image, Fl_Pixmap, Fl_Bitmap, Fl_Tiled_Image, Fl_Anim_GIF_Image and Fl_Shared_Image. Returned objects copied from images of other, derived, image classes belong to the parent class appearing in this list. For example, the copy of an Fl_GIF_Image is an object of class Fl_Pixmap.
  Since FLTK 1.4.0 this method is 'const'. If you derive your own class from Fl_Image or any subclass your overridden methods of 'Fl_Image::copy() const' and 'Fl_Image::copy(int, int) const' must also be 'const' for inheritance to work properly. This is different than in FLTK 1.3.x and earlier where these methods have not been 'const'.

Reimplemented from Fl_Image.

## ◆ draw()

void Fl_Bitmap::draw | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | cx = 0,
|  | int | cy = 0 )
| virtual

Draws the image to the current drawing surface with a bounding box.

Arguments X,Y,W,H specify a bounding box for the image, with the origin (upper-left corner) of the image offset by the `cx` and `cy` arguments.

In other words: fl_push_clip(X,Y,W,H) is applied, the image is drawn with its upper-left corner at X-cx,Y-cy and its own width and height, fl_pop_clip() is applied.

Reimplemented from Fl_Image.

## ◆ label() [1/2]

void Fl_Bitmap::label | ( | Fl_Menu_Item * | m | ) |
| virtual

This method is an obsolete way to set the image attribute of a menu item.

Deprecated
  Please use Fl_Menu_Item::image() instead.

Reimplemented from Fl_Image.

## ◆ label() [2/2]

void Fl_Bitmap::label | ( | Fl_Widget * | widget | ) |
| virtual

This method is an obsolete way to set the image attribute of a widget or menu item.

Deprecated
  Please use Fl_Widget::image() or Fl_Widget::deimage() instead.

Reimplemented from Fl_Image.

## ◆ uncache()

void Fl_Bitmap::uncache | ( |  | ) |
| virtual

If the image has been cached for display, delete the cache data.

This allows you to change the data used for the image and then redraw it without recreating an image object.

Reimplemented from Fl_Image.

The documentation for this class was generated from the following files:

- Fl_Bitmap.H
- Fl_Bitmap.cxx